package mapReduce;

import java.io.*;
import java.net.*;

public class HTTPRequestPoster {

	private final String newYorkTimesApiKey = "8386ea538106dea965a32ba283d5dadf:8:64748704";
	private final String newYorkTimesBaseURL = "http://api.nytimes.com/svc/search/v1/article?";
	private final String resultFormat = "format=json&";
	private final String offsetString = "&offset="; 
	
	public String getNewYorkTimesRequest(String keyword, Integer offset) {

		StringBuilder request = new StringBuilder(496);
		request.append(newYorkTimesBaseURL);
		request.append(resultFormat);
		request.append("query=");
		request.append(keyword);
		request.append(offsetString);
		request.append(offset.toString());
		request.append("&api-key=");
		request.append(newYorkTimesApiKey);

		String newYorkTimesRequest = request.toString();

		return newYorkTimesRequest;
	}

	public String sendGetRequest(String endpoint) {
		
		String result = null;
		if (endpoint.startsWith("http://")) {
			try {
				String urlStr = endpoint;

				URL requestUrl = new URL(urlStr);
				URLConnection connection = requestUrl.openConnection();
				
				BufferedReader dataReader = new BufferedReader(new InputStreamReader(connection.getInputStream()));
				StringBuffer data = new StringBuffer();
				String line;
				
				while ((line = dataReader.readLine()) != null) {
					data.append(line);
				}
				dataReader.close();

				result = data.toString();

			} catch (Exception e) {
				e.printStackTrace();
			}
		}
	
		return result;
	}
}
